<?php

// Фреймворк Telegram
use Zanzara\Zanzara;
use Zanzara\Context;
use Zanzara\Config;

// Фреймворк для Google Sheets
use Flow\ETL\Adapter\GoogleSheet\GoogleSheetRange,
	Flow\ETL\Adapter\GoogleSheet\GoogleSheetExtractor,
	Flow\ETL\Adapter\GoogleSheet\Columns,
	Flow\ETL\Flow,
	Flow\ETL\Config as _config,
	Flow\ETL\FlowContext,
	Flow\ETL\Row\Entry,
	Flow\ETL\Row,
	Flow\ETL\DSL\To,
	Flow\ETL\DSL\From;

// Фреймворк для Google API
use Google\Client,
	Google\Service\Sheets,
	Google\Service\Sheets\ValueRange;


require __DIR__ . '/../../../../../../../vendor/autoload.php';

ini_set('error_reporting', E_ALL);
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);

$config = new Config();
$config->setParseMode(Config::PARSE_MODE_MARKDOWN);

$bot = new Zanzara(require(__DIR__ . '/../settings/key.php'), $config);

$bot->onMessage(function (Context $ctx) {
	if ($members = $ctx->getMessage()->getNewChatMembers()) {
		// Новый аккаунт в чате

		$ctx->sendMessage('⚠️ Введите ваш табельный номер для авторизации', ['reply_to_message_id' => $ctx->getMessage()->getMessageId()])
			->then(function ($message) use ($ctx, $members) {
				// Инициализация идентификатора сотрудника
				$id = $members[0]->getId();

				$ctx->getGlobalDataItem("member_{$id}_request")
					->then(
						function ($old) use ($ctx, $id, $message) {

							$timer = function ($ctx, $id, $message) {
								$ctx->setGlobalDataItem("member_{$id}_request", $message)
									->then(function () use ($ctx, $id) {

										// Инициализация таймера
										React\Promise\Timer\sleep(180)->then(
											function () use ($ctx, $id) {

												$ctx->getGlobalDataItem("member_{$id}_request")
													->then(
														function ($message) use ($ctx, $id) {
															if ($message) {
																// Изгнание из чата
																$ctx->kickChatMember($message->getChat()->getId(), $id)
																	->then(function () use ($ctx, $id, $message) {
																		// Удаление сообщения из сессионного хранилища
																		$ctx->deleteGlobalDataItem("member_{$id}_request");

																		// Удаление сообщения 
																		$ctx->deleteMessage($message->getChat()->getId(), $message->getMessageId());
																	});
															}
														},
														function () {
														}
													);
											}
										);
									});
							};

							if ($old) {
								$ctx->deleteGlobalDataItem("member_{$id}_request")
									->then(function () use ($ctx, $id, $message, $timer, $old) {
										$ctx->deleteMessage($old->getChat()->getId(), $old->getMessageId())
											->then(function () use ($ctx, $id, $message, $timer) {
												$timer($ctx, $id, $message);
											});
									});
							} else $timer($ctx, $id, $message);
						}
					);
			});
	} else {
		// Любое сообщение

		// Инициализация сообщения
		$message = $ctx->getMessage();

		// Инициализация идентификатора отправителя сообщения
		$id = $message->getFrom()->getId();

		$ctx->getGlobalDataItem("member_{$id}_request")
			->then(
				function ($_message) use ($ctx, $id, $message) {
					if ($_message) {
						// Инициализация переданного идентификатора (только цифры)
						$worker = preg_replace('/[^\d]/', '', $message->getText() ?? '');

						$settings = json_decode(require(__DIR__ . '/../settings/workers/google.php'), true);
						$document = require(__DIR__ . '/../settings/workers/document.php');
						$sheets = require(__DIR__ . '/../settings/workers/sheets.php');

						$client = new Client();
						$client->setScopes(Sheets::SPREADSHEETS);
						$client->setAuthConfig($settings);
						$api = new Sheets($client);

						foreach ($sheets as $sheet) {
							$rows = (new Flow())->read(new GoogleSheetExtractor($api, $document, new Columns($sheet, 'A', 'A'), true, 1000));

							foreach ($rows->fetch(10000) as $row) {
								// Перебор строк

								if ($worker === $row->toArray()['ID']) {
									$ctx->sendMessage("✅ Авторизован сотрудник: $worker", ['reply_to_message_id' => $message->getMessageId()]);

									// Удаление сообщения из сессионного хранилища
									$ctx->deleteGlobalDataItem("member_{$id}_request");

									// Удаление сообщения 
									$ctx->deleteMessage($_message->getChat()->getId(), $_message->getMessageId());

									return;
								}
							}
						}

						if (!empty($worker)) $ctx->sendMessage("⛔ Не найден сотрудник: $id", ['reply_to_message_id' => $message->getMessageId()]);
					}
				}
			);
	}
});

$bot->run();
